<?php

require_once 'batchexportperm.civix.php';
use CRM_Batchexportperm_ExtensionUtil as E;

/**
 * Implements hook_civicrm_config().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_config
 */
function batchexportperm_civicrm_config(&$config) {
  _batchexportperm_civix_civicrm_config($config);
}

/**
 * Implements hook_civicrm_xmlMenu().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_xmlMenu
 */
function batchexportperm_civicrm_xmlMenu(&$files) {
  _batchexportperm_civix_civicrm_xmlMenu($files);
}

/**
 * Implements hook_civicrm_install().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_install
 */
function batchexportperm_civicrm_install() {
  _batchexportperm_civix_civicrm_install();
}

/**
 * Implements hook_civicrm_postInstall().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_postInstall
 */
function batchexportperm_civicrm_postInstall() {
  _batchexportperm_civix_civicrm_postInstall();
}

/**
 * Implements hook_civicrm_uninstall().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_uninstall
 */
function batchexportperm_civicrm_uninstall() {
  _batchexportperm_civix_civicrm_uninstall();
}

/**
 * Implements hook_civicrm_enable().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_enable
 */
function batchexportperm_civicrm_enable() {
  _batchexportperm_civix_civicrm_enable();
}

/**
 * Implements hook_civicrm_disable().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_disable
 */
function batchexportperm_civicrm_disable() {
  _batchexportperm_civix_civicrm_disable();
}

/**
 * Implements hook_civicrm_upgrade().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_upgrade
 */
function batchexportperm_civicrm_upgrade($op, CRM_Queue_Queue $queue = NULL) {
  return _batchexportperm_civix_civicrm_upgrade($op, $queue);
}

/**
 * Implements hook_civicrm_managed().
 *
 * Generate a list of entities to create/deactivate/delete when this module
 * is installed, disabled, uninstalled.
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_managed
 */
function batchexportperm_civicrm_managed(&$entities) {
  _batchexportperm_civix_civicrm_managed($entities);
  $entities[] = [
    'module' => 'org.agbu.batchexportperm',
    'name' => 'batchexportperm_batch_details',
    'entity' => 'CustomGroup',
    'params' => [
      'version' => 3,
      'name' => 'batchexportperm_batch_details',
      'title' => 'Batch Details',
      'extends' => 'Contribution',
      'style' => 'Inline',
      'collapse_display' => 1,
      'is_active' => TRUE,
      'is_multiple' => FALSE,
      'collapse_adv_display' => 0,
      'is_reserved' => TRUE,
    ],
  ];
  $entities[] = [
    'module' => 'org.agbu.batchexportperm',
    'name' => 'export_date',
    'entity' => 'CustomField',
    'params' => [
      'version' => 3,
      'name' => 'export_date',
      'label' => 'Export Date',
      'data_type' => 'Date',
      'html_type' => 'Select Date',
      'is_required' => FALSE,
      'is_searchable' => FALSE,
      'is_search_range' => FALSE,
      'is_active' => TRUE,
      'is_view' => TRUE,
      'date_format' => 'mm/dd/yy',
      'time_format' => 1,
      'text_length' => 255,
      'column_name' => 'export_date',
      'note_columns' => 150,
      'note_rows' => 4,
      'custom_group_id' => 'batchexportperm_batch_details',
    ],
  ];
}

/**
 * Implements hook_civicrm_caseTypes().
 *
 * Generate a list of case-types.
 *
 * Note: This hook only runs in CiviCRM 4.4+.
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_caseTypes
 */
function batchexportperm_civicrm_caseTypes(&$caseTypes) {
  _batchexportperm_civix_civicrm_caseTypes($caseTypes);
}

/**
 * Implements hook_civicrm_angularModules().
 *
 * Generate a list of Angular modules.
 *
 * Note: This hook only runs in CiviCRM 4.5+. It may
 * use features only available in v4.6+.
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_angularModules
 */
function batchexportperm_civicrm_angularModules(&$angularModules) {
  _batchexportperm_civix_civicrm_angularModules($angularModules);
}

/**
 * Implements hook_civicrm_alterSettingsFolders().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_alterSettingsFolders
 */
function batchexportperm_civicrm_alterSettingsFolders(&$metaDataFolders = NULL) {
  _batchexportperm_civix_civicrm_alterSettingsFolders($metaDataFolders);
}

/**
 * Implements hook_civicrm_entityTypes().
 *
 * Declare entity types provided by this module.
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_entityTypes
 */
function batchexportperm_civicrm_entityTypes(&$entityTypes) {
  _batchexportperm_civix_civicrm_entityTypes($entityTypes);
}

/**
 * Implements hook_civicrm_permission().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_permission
 */
function batchexportperm_civicrm_permission(&$permissions) {
  $prefix = ts('CiviCRM') . ': ';
  $permissions['edit exported contributions'] = [
    $prefix . ts('Edit exported contributions'),
    ts('Edit exported contributions'),
  ];
}

/**
 * Implements hook_civicrm_links().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_links
 */
function batchexportperm_civicrm_links($op, $objectName, $objectId, &$links, &$mask, &$values) {
  if ($op == 'contribution.selector.row' && $objectName == 'Contribution') {
    if (!_batchexportperm_civicrm_allow_contribution_to_edit($objectId)) {
      foreach ($links as $key => $link) {
        if ($link['name'] == 'Edit') {
          unset($links[$key]);
        }
      }
    }
  }
}

/**
 * Implements hook_civicrm_pre().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_pre
 */
function batchexportperm_civicrm_pre($op, $objectName, $id, &$params) {
  if ($op == 'edit' && $objectName == 'Contribution') {
    _batchexportperm_civicrm_check_permission($id);
  }

  if ($objectName == 'Batch' && $op == 'edit') {
    if (!empty($params['status_id'])) {
      $exportedStatusId = CRM_Core_PseudoConstant::getKey('CRM_Batch_BAO_Batch', 'status_id', 'Exported');
      if ($exportedStatusId != $params['status_id']) {
        return NULL;
      }
      $oldStatusId = civicrm_api3('Batch', 'getvalue', [
        'return' => "status_id",
        'id' => $id,
      ]);
      if ($oldStatusId != $params['status_id']) {
        CRM_Core_Smarty::singleton()->assign("batch_status_change_{$id}", TRUE);
      }
    }
  }
}

/**
 * Implements hook_civicrm_apiWrappers().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_apiWrappers
 */
function batchexportperm_civicrm_apiWrappers(&$wrappers, $apiRequest) {
  if ($apiRequest['entity'] == 'Contribution' && $apiRequest['action'] == 'create') {
    $contibutionId = CRM_Utils_Array::value('id', $apiRequest['params']);
    _batchexportperm_civicrm_check_permission($contibutionId, 'exception');
  }
}

/**
 * Implements hook_civicrm_preProcess().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_preProcess
 */
function batchexportperm_civicrm_preProcess($formName, &$form) {
  if ($formName == 'CRM_Contribute_Form_Contribution' && $form->_action & CRM_Core_Action::UPDATE) {
    $contributionId = $form->_id;
    _batchexportperm_civicrm_check_permission($contributionId);
  }
}

/**
 * Check if user has permission to update contribution.
 *
 * @param int $contributionId
 * @param string $errorType
 */
function _batchexportperm_civicrm_check_permission($contributionId, $errorType = NULL) {
  if (empty($contributionId) || _batchexportperm_civicrm_allow_contribution_to_edit($contributionId)) {
    return FALSE;
  }
  $message = ts('You do not have the necessary permission to edit this contribution.');
  if ($errorType == 'exception') {
    throw new API_Exception($message);
  }
  else {
    CRM_Core_Error::statusBounce($message);
  }
}

/**
 * Check if user has permission to update contribution.
 *
 * @param int $contributionId
 */
function _batchexportperm_civicrm_allow_contribution_to_edit($contributionId) {
  $customFieldId = civicrm_api3('CustomField', 'getvalue', [
    'return' => "id",
    'custom_group_id' => "batchexportperm_batch_details",
    'name' => "export_date",
  ]);
  $exportDate = civicrm_api3('Contribution', 'get', [
    'return' => "custom_{$customFieldId}",
    'id' => $contributionId,
    'sequential' => 1,
  ])['values'][0]["custom_{$customFieldId}"];
  CRM_Core_Error::debug('exportdate', $exportDate);
  if (empty($exportDate) || CRM_Core_Permission::check('edit exported contributions')) {
    return TRUE;
  }
  return FALSE;
}

/**
 * Implements hook_civicrm_post().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_post
 */
function batchexportperm_civicrm_post($op, $objectName, $objectId, &$objectRef) {
  if ($objectName == 'Batch' && $op == 'edit') {
    if (CRM_Core_Smarty::singleton()->get_template_vars("batch_status_change_{$objectId}")) {
      _batchexportperm_civicrm_update_contribution_exporteddate($objectId);
      CRM_Core_Smarty::singleton()->assign("batch_status_change_{$objectId}", FALSE);
    }
  }
}

/**
 * Set export date custom field for contribution when batch is exported.
 *
 * @param int $batchId
 */
function _batchexportperm_civicrm_update_contribution_exporteddate($batchId) {
  $customFieldId = civicrm_api3('CustomField', 'getvalue', [
    'return' => "id",
    'custom_group_id' => "batchexportperm_batch_details",
    'name' => "export_date",
  ]);
  $sql = "SELECT cc.id contribution_id
    FROM civicrm_contribution cc
      INNER JOIN civicrm_entity_financial_trxn ceft
        ON ceft.entity_id = cc.id AND ceft.entity_table = 'civicrm_contribution'
      INNER JOIN civicrm_entity_batch ceb
        ON ceb.entity_id = ceft.financial_trxn_id
          AND ceb.entity_table = 'civicrm_financial_trxn' AND ceb.batch_id = {$batchId}
    GROUP BY cc.id";
  $dao = CRM_Core_DAO::executeQuery($sql);
  while ($dao->fetch()) {
    civicrm_api3('Contribution', 'create', [
      'id' => $dao->contribution_id,
      "custom_{$customFieldId}" => date('Y-m-d H:i:s'),
    ]);
  }
}
